## libeufin-0.9.4a-sources.tar.gz

=== Makefile ===
# This Makefile has been placed under the public domain

include build-system/config.mk

# Default target, must be at the top.
# Should be changed with care to not break (Debian) packaging.
all: build

git-archive-all = ./build-system/taler-build-scripts/archive-with-submodules/git_archive_all.py
git_tag=$(shell git describe --tags)
gradle_version=$(shell ./gradlew -q libeufinVersion)

define versions_check =
  if test $(git_tag) != "v$(gradle_version)"; \
    then echo WARNING: Project version from Gradle: $(gradle_version) differs from current Git tag: $(git_tag); fi
endef

# Absolute DESTDIR or empty string if DESTDIR unset/empty
abs_destdir=$(abspath $(DESTDIR))

man_dir=$(abs_destdir)$(prefix)/share/man
spa_dir=$(abs_destdir)$(prefix)/share/libeufin/spa
sql_dir=$(abs_destdir)$(prefix)/share/libeufin/sql
config_dir=$(abs_destdir)$(prefix)/share/libeufin/config.d
bin_dir=$(abs_destdir)$(prefix)/bin
lib_dir=$(abs_destdir)$(prefix)/lib


# While the gradle command sounds like it's installing something,
# it's like a destdir install that only touches the source tree.
.PHONY: build
build:
	./gradlew bank:installShadowDist nexus:installShadowDist


.PHONY: dist
dist:
	$(call versions_check)
	mkdir -p build/distributions
	$(git-archive-all) --include ./configure build/distributions/libeufin-$(shell ./gradlew -q libeufinVersion)-sources.tar.gz

.PHONY: deb
deb:
	dpkg-buildpackage -rfakeroot -b -uc -us

# The install-nobuild-* targets install under the assumption
# that the compile step has already been run.

# Install without attempting to build first
.PHONY: install-nobuild
install-nobuild: install-nobuild-bank install-nobuild-nexus


.PHONY: install-nobuild-files
install-nobuild-files:
	install -m 644 -D -t $(config_dir) contrib/currencies.conf 
	install -m 644 -D -t $(config_dir) contrib/bank.conf
	install -m 644 -D -t $(config_dir) contrib/nexus.conf
	install -m 644 -D -t $(sql_dir) database-versioning/versioning.sql 
	install -m 644 -D -t $(sql_dir) database-versioning/libeufin-bank*.sql
	install -m 644 -D -t $(sql_dir) database-versioning/libeufin-nexus*.sql
	install -m 644 -D -t $(sql_dir) database-versioning/libeufin-conversion*.sql
	install -D -t $(bin_dir) contrib/libeufin-dbconfig
	install -D -t $(bin_dir) contrib/libeufin-tan-*.sh

.PHONY: install-nobuild-bank
install-nobuild-bank: install-nobuild-files
	install -d $(spa_dir)
	cp contrib/wallet-core/demobank/* $(spa_dir)/
	install -d $(abs_destdir)$(prefix)
	install -d $(bin_dir)
	install -d $(lib_dir)
	install -D -t $(bin_dir) contrib/libeufin-bank-dbinit
	install -D -t $(bin_dir) bank/build/install/bank-shadow/bin/libeufin-bank
	install -m=644 -D -t $(lib_dir) bank/build/install/bank-shadow/lib/bank-*.jar

.PHONY: install-nobuild-nexus
install-nobuild-nexus: install-nobuild-files
	install -m 644 -D -t $(man_dir)/man1 doc/prebuilt/man/libeufin-nexus.1
	install -m 644 -D -t $(man_dir)/man5 doc/prebuilt/man/libeufin-nexus.conf.5
	install -D -t $(bin_dir) contrib/libeufin-nexus-dbinit
	install -D -t $(bin_dir) nexus/build/install/nexus-shadow/bin/libeufin-nexus
	install -m 644 -D -t $(lib_dir) nexus/build/install/nexus-shadow/lib/nexus-*.jar

.PHONY: install
install:
	$(MAKE) build
	$(MAKE) install-nobuild

.PHONY: assemble
assemble:
	./gradlew assemble

.PHONY: check
check: install-nobuild-files
	./gradlew check

.PHONY: bank-test
bank-test: install-nobuild-files
	./gradlew :bank:test --tests $(test) -i

.PHONY: nexus-test
nexus-test: install-nobuild-files
	./gradlew :nexus:test --tests $(test) -i

.PHONY: ebics-test
ebics-test: install-nobuild-files
	./gradlew :ebics:test --tests $(test) -i

.PHONY: common-test
common-test: install-nobuild-files
	./gradlew :common:test --tests $(test) -i

.PHONY: testbench-test
testbench-test: install-nobuild-files
	./gradlew :testbench:test --tests $(test) -i

.PHONY: testbench
testbench: install-nobuild-files
	./gradlew :testbench:run --console=plain --args="$(platform)"

.PHONY: doc
doc:
	./gradlew dokkaHtmlMultiModule
	echo "Open build/dokka/htmlMultiModule/index.html"

=== debian/changelog ===
libeufin (0.9.4a) unstable; urgency=low

  * Package v0.9.4a

 -- Florian Dold <dold@taler.net>  Thu, 07 Mar 2024 23:48:43 +0100

libeufin (0.9.4) unstable; urgency=low

  * Package v0.9.4

 -- Florian Dold <dold@taler.net>  Thu, 07 Mar 2024 22:29:35 +0100

libeufin (0.9.4~dev.30) unstable; urgency=low

  * Package v0.9.4-dev.30

 -- Florian Dold <dold@taler.net>  Tue, 05 Mar 2024 22:29:35 +0100

libeufin (0.9.4~dev.29) unstable; urgency=low

  * Package v0.9.4-dev.29

 -- Florian Dold <dold@taler.net>  Tue, 27 Feb 2024 16:33:25 +0100

libeufin (0.9.4~dev.28) unstable; urgency=low

  * Package v0.9.4-dev.28

 -- Florian Dold <dold@taler.net>  Mon, 26 Feb 2024 17:09:51 +0100

libeufin (0.9.4~dev.27) unstable; urgency=low

  * Package v0.9.4-dev.27

 -- Florian Dold <dold@taler.net>  Wed, 21 Feb 2024 11:43:56 +0100

libeufin (0.9.4~dev.26) unstable; urgency=low

  * Package v0.9.4-dev.26

 -- Florian Dold <dold@taler.net>  Tue, 20 Feb 2024 17:19:54 +0100

libeufin (0.9.4~dev.25) unstable; urgency=low

  * Package v0.9.4-dev.25

 -- Florian Dold <dold@taler.net>  Mon, 19 Feb 2024 18:33:22 +0100

libeufin (0.9.4~dev.22) unstable; urgency=low

  * Package git tag v0.9.4-dev.22

 -- Florian Dold <dold@taler.net>  Fri, 16 Feb 2024 00:43:38 +0100

libeufin (0.9.4~dev.20) unstable; urgency=low

  * Package git tag v0.9.4-dev.20

 -- Florian Dold <dold@taler.net>  Wed, 14 Feb 2024 10:22:09 +0100

libeufin (0.9.4~dev.18) unstable; urgency=low

  * Package git tag v0.9.4-dev.18

 -- Florian Dold <dold@taler.net>  Fri, 09 Feb 2024 21:50:18 +0100

libeufin (0.9.3-11) unstable; urgency=low

  * Package v0.9.3-dev.7

 -- Florian Dold <dold@taler.net>  Mon, 29 Jan 2024 12:55:33 +0100

libeufin (0.9.3-9) unstable; urgency=low

  * Package v0.9.3-dev.4

 -- Florian Dold <dold@taler.net>  Fri, 19 Jan 2024 23:35:45 +0100

libeufin (0.9.3-8) unstable; urgency=low

  * Misc. bugfixes.

 -- Christian Grothoff <grothoff@gnu.org>  Tue, 13 Dec 2023 18:50:12 -0700

libeufin (0.9.3-7) unstable; urgency=low

  * Improvements to account creation.
  * Return more configuration data in /config.

 -- Christian Grothoff <grothoff@gnu.org>  Thu, 7 Dec 2023 00:50:12 -0800

libeufin (0.9.3-6) unstable; urgency=medium

  * Add CLI for account creation, minor bugfixes.

 -- Christian Grothoff <grothoff@gnu.org>  Mon, 4 Dec 2023 14:13:55 -0600

libeufin (0.9.3-5) unstable; urgency=medium

  * Add fix for idempotency of account creation.

 -- Christian Grothoff <grothoff@gnu.org>  Sat, 2 Dec 2023 16:13:55 -0600

libeufin (0.9.3-4) unstable; urgency=medium

  * Avoid conflicting double-initialization of DB versioning by bank and nexus.

 -- Christian Grothoff <grothoff@gnu.org>  Fri, 1 Dec 2023 19:47:55 -0600

libeufin (0.9.3-3) unstable; urgency=medium

  * Proper setup for database sharing needed for currency conversion
  * Coherent nginx configuration with default libeufin-bank configuration

 -- Christian Grothoff <grothoff@gnu.org>  Wed, 30 Nov 2023 15:47:55 -0600

libeufin (0.9.3-2) unstable; urgency=medium

  * Improved currency conversion implementation

 -- Florian Dold <dold@taler.net>  Wed, 29 Nov 2023 20:57:55 +0100

libeufin (0.9.3-1) unstable; urgency=medium

  * Also package libeufin-nexus
  * Various other packaging improvements

 -- Florian Dold <dold@taler.net>  Mon, 27 Nov 2023 21:54:22 +0100

libeufin (0.9.3) unstable; urgency=medium

  * Starting to package for v0.9.3.

 -- Christian Grothoff <grothoff@gnu.org>  Sat, 4 Mar 2023 14:47:04 +0200

libeufin (0.9.2-2) unstable; urgency=medium

  * Try to fix DB setup rules.

 -- Christian Grothoff <grothoff@gnu.org>  Sat, 4 Mar 2023 14:47:04 +0200

libeufin (0.9.2-1) unstable; urgency=medium

  * Add SPA.

 -- Christian Grothoff <grothoff@gnu.org>  Sat, 4 Mar 2023 14:46:04 +0200

libeufin (0.9.2) unstable; urgency=medium

  * New upstream release.

 -- Christian Grothoff <grothoff@gnu.org>  Tue, 21 Feb 2023 14:46:04 +0200

libeufin (0.9.1) unstable; urgency=medium

  * Prepare for first proper release.

 -- Christian Grothoff <grothoff@gnu.org>  Sat, 21 Jan 2023 14:46:04 +0200

libeufin (0.0.1-12) unstable; urgency=medium

  * Fix key letter generation.

 -- Florian Dold <florian@dold.me>  Thu, 14 Oct 2021 14:46:04 +0200

libeufin (0.0.1-11) unstable; urgency=medium

  * Add anastasis facade to the nexus.

 -- Florian Dold <florian@dold.me>  Tue, 24 Aug 2021 18:40:11 +0200

libeufin (0.0.1-10) unstable; urgency=medium

  * Add BIC validation to nexus and sandbox.

 -- Florian Dold <florian@dold.me>  Sat, 07 Aug 2021 21:40:28 +0200

libeufin (0.0.1-9) unstable; urgency=medium

  * Various bugfixes.

 -- Florian Dold <florian@dold.me>  Sat, 07 Aug 2021 16:09:59 +0200

libeufin (0.0.1-8) unstable; urgency=medium

  * Various bugfixes.

 -- Florian Dold <florian@dold.me>  Sat, 07 Aug 2021 14:32:14 +0200

libeufin (0.0.1-7) unstable; urgency=medium

  * New sandbox simulate-incoming-transaction command.

 -- Florian Dold <florian@dold.me>  Fri, 06 Aug 2021 00:08:52 +0200

libeufin (0.0.1-6) unstable; urgency=medium

  * Fix trailing slash in facade URL.

 -- Florian Dold <florian@dold.me>  Tue, 03 Aug 2021 14:43:33 +0200

libeufin (0.0.1-5) unstable; urgency=medium

  * Fix facade URL.

 -- Florian Dold <florian@dold.me>  Tue, 03 Aug 2021 14:43:33 +0200

libeufin (0.0.1-4) unstable; urgency=medium

  * Bugfixes in libeufin-cli and libeufin-nexus.

 -- Florian Dold <florian@dold.me>  Tue, 03 Aug 2021 13:59:52 +0200

libeufin (0.0.1-3) unstable; urgency=medium

  * Sandbox bugfixes.
  * Packaging: Install tmpfiles properly.

 -- Florian Dold <florian@dold.me>  Mon, 02 Aug 2021 19:53:44 +0200

libeufin (0.0.1-2) unstable; urgency=medium

  * Support debhelper-compat level 12.

 -- Florian Dold <florian@dold.me>  Sun, 01 Aug 2021 18:50:25 +0200

libeufin (0.0.1-1) unstable; urgency=medium

  * Packaging fixes.

 -- Florian Dold <florian@dold.me>  Sat, 31 Jul 2021 16:34:40 +0200

libeufin (0.0.1) unstable; urgency=low

  * Initial Release.



=== debian/control ===
Source: libeufin
Section: net
Priority: optional
Maintainer: Taler Systems SA <deb@taler.net>
Uploaders: Christian Grothoff <grothoff@gnu.org>, Florian Dold <dold@taler.net>
Build-Depends:
 debhelper-compat (= 12),
 unzip,
 python3-distutils,
 openjdk-17-jdk-headless | openjdk-17-jdk | openjdk-18-jdk-headless | openjdk-18-jdk | openjdk-19-jdk-headless | openjdk-19-jdk | openjdk-20-jdk-headless | openjdk-20-jdk | openjdk-21-jdk-headless | openjdk-21-jdk
Standards-Version: 4.1.0
Vcs-Git: https://git.taler.net/libeufin.git
Homepage: https://taler.net/

Package: libeufin-common
Architecture: all
Depends: ${misc:Depends}
Description: Common files for other libeufin packages.

Package: libeufin-bank
Architecture: all
Depends:
 openjdk-17-jdk-headless | openjdk-17-jdk | openjdk-18-jdk-headless | openjdk-18-jdk | openjdk-19-jdk-headless | openjdk-19-jdk | openjdk-20-jdk-headless | openjdk-20-jdk | openjdk-21-jdk-headless | openjdk-21-jdk,
 libeufin-common (= ${binary:Version}),
 ${misc:Depends}
Recommends:
 apache2 | nginx | httpd,
 postgresql (>= 13.0)
Description: Software package to provide a regional bank with optional EBICS access.

Package: libeufin-nexus
Architecture: all
Depends:
 openjdk-17-jdk-headless | openjdk-17-jdk | openjdk-18-jdk-headless | openjdk-18-jdk | openjdk-19-jdk-headless | openjdk-19-jdk | openjdk-20-jdk-headless | openjdk-20-jdk | openjdk-21-jdk-headless | openjdk-21-jdk,
 libeufin-common (= ${binary:Version}),
 ${misc:Depends}
Recommends:
 apache2 | nginx | httpd,
 postgresql (>= 13.0)
Description: Software package to access a bank accounts via the EBICS protocol.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk

SHELL := sh -e

export GRADLE_USER_HOME = .gradle
LIBEUFIN_HOME = /usr/share/libeufin
DEV =
FULLVER = $(DEB_VERSION_UPSTREAM)$(DEV)

%:
	dh ${@} --no-parallel

override_dh_auto_test:
	true

override_dh_auto_configure:
	./configure --prefix=/usr

# Since this step is run under fakeroot and gradle
# doesn't work under fakeroot, we must make sure
# that everything is built by gradle before.
# The install-nobuild target installs under the assumption
# that everything is already built.
override_dh_auto_install:
	make -j1 install-nobuild DESTDIR=$(CURDIR)/debian/tmp

# Override this step because it's very slow and likely
# unnecessary for us.
override_dh_strip_nondeterminism:
	true

override_dh_install:
	dh_install
# Needs to be called manually for debhelper-compat < 13
	dh_installtmpfiles

override_dh_installsystemd:
	# Need to specify units manually, since we have multiple
	# and dh_installsystemd by default only looks for "<package>.service".
	dh_installsystemd -plibeufin-bank --name=libeufin-bank --no-start --no-enable
	dh_installsystemd -plibeufin-nexus --name=libeufin-nexus-ebics-submit --no-start --no-enable
	dh_installsystemd -plibeufin-nexus --name=libeufin-nexus-ebics-fetch --no-start --no-enable
	# final invocation to generate daemon reload
	dh_installsystemd

get-orig-source:
	uscan --force-download --rename
